program create_xml;

{$mode objfpc}{$H+}

uses
  Classes, SysUtils;

const
  fn = 'data.xml';    // output file
  N = 500000;           // Count of <si> nodes

  procedure AppendToStream(AStream: TStream; AText: String);
  begin
    if AText <> '' then
    begin
      AStream.WriteBuffer(AText[1], Length(AText));
      AStream.WriteBuffer(LineEnding[1], Length(LineEnding));
    end;
  end;

  function CreateRandomString: String;
  var
    i: Integer;
  begin
    SetLength(Result, Random(20) + 1);
    for i:=1 to Length(Result) do
      Result[i] := char(ord('a') + random(26));
  end;

var
  Stream: TMemoryStream;
  i: Integer;
  s: String;

begin
  Stream := TMemoryStream.Create;
  try
    AppendToStream(Stream, '<?xml version="1.0" encoding="UTF-8" standalone="yes" ?>');
    AppendToStream(Stream, '<sst xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main">');
    for i:=1 to N do begin
      s := CreateRandomString;
      AppendToStream(Stream, '  <si>');
      AppendToStream(Stream, '    <t>' + s + '</t>');
      AppendToStream(Stream, '  </si>');
    end;
    AppendToStream(Stream, '</sst>');

    WriteLn(N, ' <si> nodes created in file "', ExpandFileName(fn), '"');
    Stream.Position := 0;
    Stream.SaveToFile(fn);
  finally
    Stream.Free;
  end;
end.

